#!/bin/sh

CACHEFILE=shelf.cache
OUTFILE=/tmp/${CACHEFILE}
F_LOCK=/var/lock/shelf.lock

SSHCMD="/usr/bin/ssh -qxT -o BatchMode=yes -o CheckHostIP=no \
-o ConnectTimeout=3 -o UserKnownHostsFile=/dev/null \
-o StrictHostKeyChecking=no"

read_host()
{
	${SSHCMD} root@${1} </usr/store/cron/shelf_read.sh >/tmp/${1}_$$ 2>/dev/null
}

update_file()
{
	local started=0
	local shelf
	local addr

	addr=`echo ${1}|sed -e 's,.*/,,g;s,_.*,,g'`
	shelf=`awk -F '=' '{print $1,$2}' /etc/default/shelves|grep $addr|awk '{print $1}'`

	while read str; do
		case "${str}" in
		__CACHE_BEGIN__)
			started=1
			continue
			;;
		__CACHE_END__)
			break
			;;
		*)
			if [ $started -ne 0 ]; then
				echo "${shelf}/${str}" >>${2}
			fi
			;;
		esac
	done <${1}
}

# Пытается прочитать данные с указанного хоста
#
# $1	- имя полки
# $2	- список адресов
test_read()
{
	local addr=`echo $2|sed -e 's/,/ /g'`

	for i in $addr; do
		read_host ${i}
#		if [ $? -eq 0 ]; then
#			echo "$1 $i" >>${LIST}
#			break;
#		fi
	done
}

[ -f ${F_LOCK} ] && exit 0
touch ${F_LOCK}

ftmp=/tmp/shelf.$$
awk -F '=' '{print $1,$2}' /etc/default/shelves >$ftmp
while read s h; do
	test_read ${s} ${h}&
done<$ftmp
rm $ftmp
wait

rm -f ${OUTFILE}
ls -1 /tmp/*_$$|while read f; do
	if [ -s $f ]; then
		update_file $f ${OUTFILE}
	fi
	rm -f $f
done

rm -f ${F_LOCK}
mv ${OUTFILE} /var/webmin/modules/shelfctl
